-- modified version created by HandyVac. all changes flagged with "-- EDIT"

local QuestScript = hmake CvQuestScript{};

----------------------------------------------------
-- Definitions
---------------------------------------------------- 
hstructure BuildingChoiceStruct
	ID : number
	Text : string
	Epilogue : string
	Flavor : number
	RewardPerkType : string
end

hstructure BuildingQuestStruct
	TitleTextKey : string
	BodyTextKey : string
	SummaryTextKey : string
	ChoiceA : BuildingChoiceStruct
	ChoiceB : BuildingChoiceStruct
end

----------------------------------------------------
-- Locals (constants)
---------------------------------------------------- 
-- EDIT ------------------------------
local TRIGGER_CHANCE = 5;
--local TRIGGER_CHANCE = 100;
--------------------------------------

local BUILDING_CHOICES_TABLE = {};

BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_RELIC"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_RELIC",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_RELIC_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_RELIC_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_RELIC_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_RELIC_CHOICE_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_CULTURE"].ID,
		RewardPerkType = "PLAYERPERK_RELICS_FREE_MAINTENANCE";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_RELIC_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_RELIC_CHOICE_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_CULTURE"].ID,
		RewardPerkType = "PLAYERPERK_RELICS_CULTURE_FLAT";
	}
}

-- EDIT --------------------------------------------------------------
print("adding choice table for Library building quest");

BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_LIBRARY_SERVER"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_LIBRARY_SERVER",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_LIBRARY_SERVER_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_LIBRARY_SERVER_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_LIBRARY_SERVER_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_LIBRARY_SERVER_CHOICE_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_SCIENCE"].ID,
		RewardPerkType = "PLAYERPERK_LIBRARY_SERVER_EXTRA_SCIENCE";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_LIBRARY_SERVER_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_LIBRARY_SERVER_CHOICE_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_CULTURE"].ID,
		RewardPerkType = "PLAYERPERK_LIBRARY_SERVER_EXTRA_CULTURE_NO_SUPREMACY";
	}
}
-----------------------------------------------------------------------
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_VIVARIUM"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_VIVARIUM",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_VIVARIUM_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_VIVARIUM_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_VIVARIUM_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_VIVARIUM_CHOICE_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_SCIENCE"].ID,
		RewardPerkType = "PLAYERPERK_VIVARIUMS_SCIENCE_FLAT";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_VIVARIUM_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_VIVARIUM_CHOICE_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_GROWTH"].ID,
		RewardPerkType = "PLAYERPERK_VIVARIUMS_FOOD_FLAT";		
	}
}

BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_CLINIC"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_CLINIC",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_CLINIC_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_CLINIC_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_CLINIC_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_CLINIC_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_CITY_DEFENSE"].ID,
		RewardPerkType = "PLAYERPERK_CLINICS_CITY_HP";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_CLINIC_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_CLINIC_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_HEALTH"].ID,
		RewardPerkType = "PLAYERPERK_CLINICS_HEALTH_FLAT";
	}
}

BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_DEPOT"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_DEPOT",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_DEPOT_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_DEPOT_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_DEPOT_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_DEPOT_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_PRODUCTION"].ID,
		RewardPerkType = "PLAYERPERK_DEPOTS_PRODUCTION_FLAT";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_DEPOT_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_DEPOT_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_I_LAND_TRADE_ROUTE"].ID,
		RewardPerkType = "PLAYERPERK_DEPOTS_ENERGY_FLAT";
	}
}

BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_PHARMALAB"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_PHARMALAB",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_PHARMALAB_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_PHARMALAB_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_PHARMALAB_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_PHARMALAB_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_SCIENCE"].ID,
		RewardPerkType = "PLAYERPERK_PHARMALABS_SCIENCE_FLAT";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_PHARMALAB_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_PHARMALAB_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_HEALTH"].ID,
		RewardPerkType = "PLAYERPERK_PHARMALABS_HEALTH_FLAT";
	}
}

-- BUILDING_ULTRASONIC_FENCE
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_ULTRASONIC_FENCE"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_ULTRASONIC_FENCE",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_ULTRASONIC_FENCE_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_ULTRASONIC_FENCE_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_ULTRASONIC_FENCE_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_ULTRASONIC_FENCE_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_CITY_DEFENSE"].ID,
		RewardPerkType = "PLAYERPERK_ULTRASONIC_FENCES_REPEL_RANGE";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_ULTRASONIC_FENCE_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_ULTRASONIC_FENCE_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_EXPANSION"].ID,
		RewardPerkType = "PLAYERPERK_TRADERS_IMMUNE_TO_ALIENS";
	}
}

-- RECYCLER
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_RECYCLER"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_RECYCLER",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_RECYCLER_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_RECYCLER_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_RECYCLER_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_RECYCLER_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_TILE_IMPROVEMENT"].ID,
		RewardPerkType = "PLAYERPERK_RECYCLERS_WORKER_SPEED";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_RECYCLER_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_RECYCLER_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_GROWTH"].ID,
		RewardPerkType = "PLAYERPERK_RECYCLERS_FOOD_FLAT";
	}
}

-- COMMAND_CENTER
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_COMMAND_CENTER"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_COMMAND_CENTER",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_COMMAND_CENTER_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_COMMAND_CENTER_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_COMMAND_CENTER_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_COMMAND_CENTER_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_CITY_DEFENSE"].ID,
		RewardPerkType = "PLAYERPERK_COMMAND_CENTERS_CITY_STRENGTH";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_COMMAND_CENTER_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_COMMAND_CENTER_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_ESPIONAGE"].ID,
		RewardPerkType = "PLAYERPERK_COMMAND_CENTERS_SPIES";
	}
}

-- WATER_PLANT
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_WATER_PLANT"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_WATER_PLANT",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_WATER_PLANT_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_WATER_PLANT_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_WATER_PLANT_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_WATER_PLANT_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_HEALTH"].ID,
		RewardPerkType = "PLAYERPERK_WATER_PLANTS_FREE_MAINTENANCE";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_WATER_PLANT_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_WATER_PLANT_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_GROWTH"].ID,
		RewardPerkType = "PLAYERPERK_WATER_PLANTS_FOOD_FLAT";
	}
}

-- LABORATORY
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_LABORATORY"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_LABORATORY",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_LABORATORY_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_LABORATORY_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_LABORATORY_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_LABORATORY_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_EXPANSION"].ID,
		RewardPerkType = "PLAYERPERK_LABORATORIES_EXPLORER_CHARGES";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_LABORATORY_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_LABORATORY_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_HEALTH"].ID,
		RewardPerkType = "PLAYERPERK_LABORATORIES_SCIENCE_FLAT";
	}
}

-- THORIUM_REACTOR
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_THORIUM_REACTOR"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_THORIUM_REACTOR",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_THORIUM_REACTOR_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_THORIUM_REACTOR_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_THORIUM_REACTOR_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_THORIUM_REACTOR_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_ENERGY"].ID,
		RewardPerkType = "PLAYERPERK_THORIUM_REACTORS_ENERGY_FLAT";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_THORIUM_REACTOR_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_THORIUM_REACTOR_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_PRODUCTION"].ID,
		RewardPerkType = "PLAYERPERK_THORIUM_REACTORS_PRODUCTION_FLAT";
	}
}

-- CYTONURSERY
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_CYTONURSERY"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_CYTONURSERY",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_CYTONURSERY_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_CYTONURSERY_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_CYTONURSERY_CHOICE_CITYHP_HARMONY",
		Epilogue = "TXT_KEY_QUEST_BUILDING_CYTONURSERY_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_CITY_DEFENSE"].ID,
		RewardPerkType = "PLAYERPERK_CYTONURSERY_CITYHP_HARMONY";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_CYTONURSERY_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_CYTONURSERY_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_PRODUCTION"].ID,
		RewardPerkType = "PLAYERPERK_CYTONURSERIES_PRODUCTION_FLAT";
	}
}

-- REPAIR_FACILITY
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_REPAIR_FACILITY"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_REPAIR_FACILITY",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_REPAIR_FACILITY_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_REPAIR_FACILITY_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_REPAIR_FACILITY_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_REPAIR_FACILITY_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_ORBITAL"].ID,
		RewardPerkType = "PLAYERPERK_REPAIR_FACILITIES_ORBITAL_COVERAGE";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_REPAIR_FACILITY_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_REPAIR_FACILITY_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_MILITARY_TRAINING"].ID,
		RewardPerkType = "PLAYERPERK_REPAIR_FACILITIES_MILITARY_PRODUCTION";
	}
}

-- OBSERVATORY
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_OBSERVATORY"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_OBSERVATORY",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_OBSERVATORY_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_OBSERVATORY_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_OBSERVATORY_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_OBSERVATORY_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_CITY_DEFENSE"].ID,
		RewardPerkType = "PLAYERPERK_OBSERVATORIES_CITY_STRENGTH";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_OBSERVATORY_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_OBSERVATORY_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_NAVAL"].ID,
		RewardPerkType = "PLAYERPERK_OBSERVATORIES_NAVAL_MOVEMENT";
	}
}

-- ALIEN_PRESERVE
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_ALIEN_PRESERVE"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_ALIEN_PRESERVE",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_ALIEN_PRESERVE_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_ALIEN_PRESERVE_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_ALIEN_PRESERVE_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_ALIEN_PRESERVE_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_DEFENSE"].ID,
		RewardPerkType = "PLAYERPERK_ALIEN_PRESERVES_UNIT_HEAL_MOD";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_ALIEN_PRESERVE_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_ALIEN_PRESERVE_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_CITY_DEFENSE"].ID,
		RewardPerkType = "PLAYERPERK_ALIEN_PRESERVES_SCIENCE_AND_ENERGY_FLAT";
	}
}

-- CLONING_PLANT
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_CLONING_PLANT"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_CLONING_PLANT",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_CLONING_PLANT_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_CLONING_PLANT_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_CLONING_PLANT_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_CLONING_PLANT_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_GROWTH"].ID,
		RewardPerkType = "PLAYERPERK_CLONING_PLANTS_GROWTH_CARRYOVER";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_CLONING_PLANT_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_CLONING_PLANT_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_HEALTH"].ID,
		RewardPerkType = "PLAYERPERK_CLONING_PLANTS_HEALTH_FLAT";
	}
}

-- PETRO_PLANT
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_PETRO_PLANT"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_PETRO_PLANT",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_PETRO_PLANT_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_PETRO_PLANT_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_PETRO_PLANT_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_PETRO_PLANT_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_PRODUCTION"].ID,
		RewardPerkType = "PLAYERPERK_PETRO_PLANTS_PETROLEUM_PRODUCTION";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_PETRO_PLANT_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_PETRO_PLANT_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_CULTURE"].ID,
		RewardPerkType = "PLAYERPERK_PETRO_PLANTS_PETROLEUM_CULTURE";
	}
}

-- LAUNCH_COMPLEX
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_LAUNCH_COMPLEX"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_LAUNCH_COMPLEX",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_LAUNCH_COMPLEX_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_LAUNCH_COMPLEX_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_LAUNCH_COMPLEX_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_LAUNCH_COMPLEX_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_ORBITAL"].ID,
		RewardPerkType = "PLAYERPERK_LAUNCH_COMPLEXES_ORBITAL_COVERAGE";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_LAUNCH_COMPLEX_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_LAUNCH_COMPLEX_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_ORBITAL"].ID,
		RewardPerkType = "PLAYERPERK_LAUNCH_COMPLEXES_ORBITAL_PRODUCTION";
	}
}

-- DEFENSE_PERIMETER
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_DEFENSE_PERIMETER"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_DEFENSE_PERIMETER",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_DEFENSE_PERIMETER_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_DEFENSE_PERIMETER_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_DEFENSE_PERIMETER_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_DEFENSE_PERIMETER_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_CITY_DEFENSE"].ID,
		RewardPerkType = "PLAYERPERK_DEFENSE_PERIMETERS_CITY_HP";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_DEFENSE_PERIMETER_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_DEFENSE_PERIMETER_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_ENERGY"].ID,
		RewardPerkType = "PLAYERPERK_DEFENSE_PERIMETERS_FREE_MAINTENANCE";
	}
}

-- ROCKET_BATTERY
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_ROCKET_BATTERY"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_ROCKET_BATTERY",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_ROCKET_BATTERY_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_ROCKET_BATTERY_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_ROCKET_BATTERY_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_ROCKET_BATTERY_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_CITY_DEFENSE"].ID,
		RewardPerkType = "PLAYERPERK_ROCKET_BATTERIES_CITY_STRENGTH";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_ROCKET_BATTERY_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_ROCKET_BATTERY_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_ORBITAL"].ID,
		RewardPerkType = "PLAYERPERK_ROCKET_BATTERIES_ORBITAL_STRIKE_RANGE";
	}
}

-- NETWORK
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_NETWORK"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_NETWORK",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_NETWORK_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_NETWORK_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_NETWORK_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_NETWORK_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_ENERGY"].ID,
		RewardPerkType = "PLAYERPERK_NETWORKS_FREE_MAINTENANCE";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_NETWORK_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_NETWORK_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_CULTURE"].ID,
		RewardPerkType = "PLAYERPERK_NETWORKS_CULTURE_FLAT";
	}
}

-- FEEDSITE_HUB
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_FEEDSITE_HUB"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_FEEDSITE_HUB",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_FEEDSITE_HUB_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_FEEDSITE_HUB_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_FEEDSITE_HUB_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_FEEDSITE_HUB_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_ESPIONAGE"].ID,
		RewardPerkType = "PLAYERPERK_FEEDSITE_HUBS_SPIES";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_FEEDSITE_HUB_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_FEEDSITE_HUB_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_TILE_IMPROVEMENT"].ID,
		RewardPerkType = "PLAYERPERK_FEEDSITE_HUBS_WORKER_SPEED";
	}
}

-- GENE_GARDEN
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_GENE_GARDEN"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_GENE_GARDEN",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_GENE_GARDEN_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_GENE_GARDEN_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_GENE_GARDEN_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_GENE_GARDEN_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_ENERGY"].ID,
		RewardPerkType = "PLAYERPERK_GENE_GARDENS_ENERGY_FLAT";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_GENE_GARDEN_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_GENE_GARDEN_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_HEALTH"].ID,
		RewardPerkType = "PLAYERPERK_GENE_GARDENS_HEALTH_FLAT";
	}
}

-- XENOFUEL_PLANT
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_XENOFUEL_PLANT"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_XENOFUEL_PLANT",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_XENOFUEL_PLANT_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_XENOFUEL_PLANT_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_XENOFUEL_PLANT_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_XENOFUEL_PLANT_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_ENERGY"].ID,
		RewardPerkType = "PLAYERPERK_XENOFUEL_PLANTS_FREE_ENERGY";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_XENOFUEL_PLANT_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_XENOFUEL_PLANT_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_TILE_IMPROVEMENT"].ID,
		RewardPerkType = "PLAYERPERK_XENOFUEL_PLANTS_XENOMASS_ENERGY_AND_PRODUCTION";
	}
}

-- XENONURSERY
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_XENONURSERY"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_XENONURSERY",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_XENONURSERY_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_XENONURSERY_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_XENONURSERY_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_XENONURSERY_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_SCIENCE"].ID,
		RewardPerkType = "PLAYERPERK_XENONURSERIES_FREE_SCIENCE";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_XENONURSERY_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_XENONURSERY_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_EXPANSION"].ID,
		RewardPerkType = "PLAYERPERK_XENONURSERIES_RESOURCE_XENOMASS";
	}
}

-- AUTOPLANT
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_AUTOPLANT"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_AUTOPLANT",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_AUTOPLANT_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_AUTOPLANT_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_AUTOPLANT_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_AUTOPLANT_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_I_LAND_TRADE_ROUTE"].ID,
		RewardPerkType = "PLAYERPERK_AUTOPLANTS_PRODUCTION_FLAT";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_AUTOPLANT_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_AUTOPLANT_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_ENERGY"].ID,
		RewardPerkType = "PLAYERPERK_AUTOPLANTS_ENERGY_FLAT";
	}
}

-- BIOFACTORY
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_BIOFACTORY"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_BIOFACTORY",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_BIOFACTORY_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_BIOFACTORY_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_BIOFACTORY_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_BIOFACTORY_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_GROWTH"].ID,
		RewardPerkType = "PLAYERPERK_BIOFACTORIES_FOOD_FLAT";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_BIOFACTORY_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_BIOFACTORY_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_HEALTH"].ID,
		RewardPerkType = "PLAYERPERK_BIOFACTORIES_CULTURE_FLAT";
	}
}

-- MASS_DIGESTER
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_MASS_DIGESTER"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_MASS_DIGESTER",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_MASS_DIGESTER_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_MASS_DIGESTER_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_MASS_DIGESTER_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_MASS_DIGESTER_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_PRODUCTION"].ID,
		RewardPerkType = "PLAYERPERK_MASS_DIGESTERS_PRODUCTION_FLAT";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_MASS_DIGESTER_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_MASS_DIGESTER_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_GROWTH"].ID,
		RewardPerkType = "PLAYERPERK_MASS_DIGESTERS_FOOD_FLAT";
	}
}

-- NEUROLAB
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_NEUROLAB"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_NEUROLAB",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_NEUROLAB_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_NEUROLAB_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_NEUROLAB_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_NEUROLAB_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_HEALTH"].ID,
		RewardPerkType = "PLAYERPERK_NEUROLABS_HEALTH_FLAT";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_NEUROLAB_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_NEUROLAB_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_MILITARY_TRAINING"].ID,
		RewardPerkType = "PLAYERPERK_NEUROLABS_MILITARY_PRODUCTION";
	}
}

-- HOLOSUITE
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_HOLOSUITE"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_HOLOSUITE",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_HOLOSUITE_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_HOLOSUITE_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_HOLOSUITE_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_HOLOSUITE_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_CULTURE"].ID,
		RewardPerkType = "PLAYERPERK_HOLOSUITES_CULTURE_FLAT";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_HOLOSUITE_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_HOLOSUITE_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_CULTURE"].ID,
		RewardPerkType = "PLAYERPERK_HOLOSUITES_FREE_VIRTUE";
	}
}

-- CEL_CRADLE
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_CEL_CRADLE"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_CEL_CRADLE",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_CEL_CRADLE_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_CEL_CRADLE_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_CEL_CRADLE_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_CEL_CRADLE_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_GROWTH"].ID,
		RewardPerkType = "PLAYERPERK_CEL_CRADLES_GROWTH_CARRYOVER";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_CEL_CRADLE_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_CEL_CRADLE_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_ESPIONAGE"].ID,
		RewardPerkType = "PLAYERPERK_CEL_CRADLES_SPIES";
	}
}

-- SURVEILLANCE_WEB
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_SURVEILLANCE_WEB"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_SURVEILLANCE_WEB",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_SURVEILLANCE_WEB_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_SURVEILLANCE_WEB_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_SURVEILLANCE_WEB_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_SURVEILLANCE_WEB_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_ESPIONAGE"].ID,
		RewardPerkType = "PLAYERPERK_SURVEILLANCE_WEB_SPY_LEVELING";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_SURVEILLANCE_WEB_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_SURVEILLANCE_WEB_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_CITY_DEFENSE"].ID,
		RewardPerkType = "PLAYERPERK_SURVEILLANCE_WEB_CITY_HP";
	}
}

-- ALLOY_FOUNDRY
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_ALLOY_FOUNDRY"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_ALLOY_FOUNDRY",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_ALLOY_FOUNDRY_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_ALLOY_FOUNDRY_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_ALLOY_FOUNDRY_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_ALLOY_FOUNDRY_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_PRODUCTION"].ID,
		RewardPerkType = "PLAYERPERK_ALLOY_FOUNDRIES_TITANIUM_PRODUCTION";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_ALLOY_FOUNDRY_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_ALLOY_FOUNDRY_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_TILE_IMPROVEMENT"].ID,
		RewardPerkType = "PLAYERPERK_ALLOY_FOUNDRIES_RESOURCE_TITANIUM";
	}
}

-- BIONICS_LAB
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_BIONICS_LAB"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_BIONICS_LAB",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_BIONICS_LAB_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_BIONICS_LAB_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_BIONICS_LAB_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_BIONICS_LAB_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_SCIENCE"].ID,
		RewardPerkType = "PLAYERPERK_BIONICS_LABS_SCIENCE_FLAT";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_BIONICS_LAB_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_BIONICS_LAB_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_CULTURE"].ID,
		RewardPerkType = "PLAYERPERK_BIONICS_LABS_CULTURE_FLAT";
	}
}

-- INSTITUTE
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_INSTITUTE"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_INSTITUTE",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_INSTITUTE_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_INSTITUTE_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_INSTITUTE_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_INSTITUTE_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_SCIENCE"].ID,
		RewardPerkType = "PLAYERPERK_INSTITUTES_SCIENCE_MOD";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_INSTITUTE_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_INSTITUTE_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_SCIENCE"].ID,
		RewardPerkType = "PLAYERPERK_INSTITUTES_FREE_TECH";
	}
}

-- BIOFUEL_PLANT
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_BIOFUEL_PLANT"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_BIOFUEL_PLANT",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_BIOFUEL_PLANT_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_BIOFUEL_PLANT_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_BIOFUEL_PLANT_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_BIOFUEL_PLANT_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_ENERGY"].ID,
		RewardPerkType = "PLAYERPERK_BIOFUEL_PLANTS_ENERGY_FLAT";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_BIOFUEL_PLANT_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_BIOFUEL_PLANT_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_PRODUCTION"].ID,
		RewardPerkType = "PLAYERPERK_BIOFUEL_PLANTS_PRODUCTION_FLAT";
	}
}

-- GAIAN_WELL
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_GAIAN_WELL"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_GAIAN_WELL",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_GAIAN_WELL_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_GAIAN_WELL_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_GAIAN_WELL_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_GAIAN_WELL_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_ENERGY"].ID,
		RewardPerkType = "PLAYERPERK_GAIAN_WELLS_ENERGY_FLAT";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_GAIAN_WELL_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_GAIAN_WELL_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_PRODUCTION"].ID,
		RewardPerkType = "PLAYERPERK_GAIAN_WELLS_PRODUCTION_FLAT";
	}
}

-- GROWLAB
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_GROWLAB"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_GROWLAB",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_GROWLAB_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_GROWLAB_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_GROWLAB_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_GROWLAB_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_PRODUCTION"].ID,
		RewardPerkType = "PLAYERPERK_GROWLABS_FREE_ENERGY";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_GROWLAB_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_GROWLAB_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_GROWTH"].ID,
		RewardPerkType = "PLAYERPERK_GROWLABS_FREE_POPULATION";
	}
}

-- GENE_SMELTER
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_GENE_SMELTER"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_GENE_SMELTER",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_GENE_SMELTER_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_GENE_SMELTER_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_GENE_SMELTER_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_GENE_SMELTER_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_SCIENCE"].ID,
		RewardPerkType = "PLAYERPERK_GENE_SMELTERS_SCIENCE_FLAT";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_GENE_SMELTER_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_GENE_SMELTER_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_HEALTH"].ID,
		RewardPerkType = "PLAYERPERK_GENE_SMELTERS_HEALTH_FLAT";
	}
}

-- XENO_SANCTUARY
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_XENO_SANCTUARY"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_XENO_SANCTUARY",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_XENO_SANCTUARY_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_XENO_SANCTUARY_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_XENO_SANCTUARY_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_XENO_SANCTUARY_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_CULTURE"].ID,
		RewardPerkType = "PLAYERPERK_XENO_SANCTUARIES_CULTURE_FLAT";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_XENO_SANCTUARY_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_XENO_SANCTUARY_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_GROWTH"].ID,
		RewardPerkType = "PLAYERPERK_XENO_SANCTUARIES_FOOD_FLAT";
	}
}

-- LEV_PLANT
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_LEV_PLANT"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_LEV_PLANT",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_LEV_PLANT_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_LEV_PLANT_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_LEV_PLANT_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_LEV_PLANT_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_PRODUCTION"].ID,
		RewardPerkType = "PLAYERPERK_LEV_PLANTS_PRODUCTION_FLAT";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_LEV_PLANT_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_LEV_PLANT_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_ENERGY"].ID,
		RewardPerkType = "PLAYERPERK_LEV_PLANTS_ENERGY_FLAT";
	}
}

-- OPTICAL_SURGERY
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_OPTICAL_SURGERY"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_OPTICAL_SURGERY",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_OPTICAL_SURGERY_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_OPTICAL_SURGERY_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_OPTICAL_SURGERY_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_OPTICAL_SURGERY_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_HEALTH"].ID,
		RewardPerkType = "PLAYERPERK_OPTICAL_SURGERIES_UNIT_VISIBILITY";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_OPTICAL_SURGERY_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_OPTICAL_SURGERY_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_SCIENCE"].ID,
		RewardPerkType = "PLAYERPERK_OPTICAL_SURGERIES_SCIENCE_FLAT";
	}
}

-- MICROBIAL_MINE
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_MICROBIAL_MINE"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_MICROBIAL_MINE",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_MICROBIAL_MINE_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_MICROBIAL_MINE_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_MICROBIAL_MINE_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_MICROBIAL_MINE_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_PRODUCTION"].ID,
		RewardPerkType = "PLAYERPERK_MICROBIAL_MINES_HARMONY_LVL_ENERGY";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_MICROBIAL_MINE_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_MICROBIAL_MINE_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_SCIENCE"].ID,
		RewardPerkType = "PLAYERPERK_MICROBIAL_MINES_HARMONY_LVL_SCIENCE";
	}
}

-- ORGAN_PRINTER
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_ORGAN_PRINTER"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_ORGAN_PRINTER",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_ORGAN_PRINTER_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_ORGAN_PRINTER_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_ORGAN_PRINTER_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_ORGAN_PRINTER_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_HEALTH"].ID,
		RewardPerkType = "PLAYERPERK_ORGAN_PRINTERS_HEALTH_MOD";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_ORGAN_PRINTER_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_ORGAN_PRINTER_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_DEFENSE"].ID,
		RewardPerkType = "PLAYERPERK_ORGAN_PRINTERS_UNIT_HEAL_MOD";
	}
}

-- CIVIL_CRECHE
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_CIVIL_CRECHE"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_CIVIL_CRECHE",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_CIVIL_CRECHE_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_CIVIL_CRECHE_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_CIVIL_CRECHE_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_CIVIL_CRECHE_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_GROWTH"].ID,
		RewardPerkType = "PLAYERPERK_CIVIL_CRECHES_FOOD_MOD";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_CIVIL_CRECHE_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_CIVIL_CRECHE_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_TILE_IMPROVEMENT"].ID,
		RewardPerkType = "PLAYERPERK_CIVIL_CRECHES_WORKER_SPEED";
	}
}

-- SOMA_DISTILLERY
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_SOMA_DISTILLERY"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_SOMA_DISTILLERY",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_SOMA_DISTILLERY_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_SOMA_DISTILLERY_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_SOMA_DISTILLERY_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_SOMA_DISTILLERY_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_HEALTH"].ID,
		RewardPerkType = "PLAYERPERK_SOMA_DISTILLERIES_HEALTH_MOD";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_SOMA_DISTILLERY_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_SOMA_DISTILLERY_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_CULTURE"].ID,
		RewardPerkType = "PLAYERPERK_SOMA_DISTILLERIES_CULTURE_MOD";
	}
}

-- TERRA_VAULT
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_TERRA_VAULT"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_TERRA_VAULT",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_TERRA_VAULT_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_TERRA_VAULT_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_TERRA_VAULT_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_TERRA_VAULT_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_CULTURE"].ID,
		RewardPerkType = "PLAYERPERK_TERRA_VAULTS_CULTURE_MOD";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_TERRA_VAULT_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_TERRA_VAULT_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_SCIENCE"].ID,
		RewardPerkType = "PLAYERPERK_TERRA_VAULTS_SCIENCE_MOD";
	}
}

-- PROGENITOR_GARDEN
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_PROGENITOR_GARDEN"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_PROGENITOR_GARDEN",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_PROGENITOR_GARDEN_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_PROGENITOR_GARDEN_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_PROGENITOR_GARDEN_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_PROGENITOR_GARDEN_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_HEALTH"].ID,
		RewardPerkType = "PLAYERPERK_PROGENITOR_GARDENS_HEALTH_MOD";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_PROGENITOR_GARDEN_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_PROGENITOR_GARDEN_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_SCIENCE"].ID,
		RewardPerkType = "PLAYERPERK_PROGENITOR_GARDENS_SCIENCE_MOD";
	}
}

-- NODE_BANK
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_NODE_BANK"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_NODE_BANK",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_NODE_BANK_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_NODE_BANK_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_NODE_BANK_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_NODE_BANK_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_CITY_DEFENSE"].ID,
		RewardPerkType = "PLAYERPERK_NODE_BANKS_CITY_HP_MOD";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_NODE_BANK_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_NODE_BANK_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_CITY_DEFENSE"].ID,
		RewardPerkType = "PLAYERPERK_NODE_BANKS_CITY_STRENGTH_MOD";
	}
}

-- BOREHOLE
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_BOREHOLE"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_BOREHOLE",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_BOREHOLE_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_BOREHOLE_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_BOREHOLE_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_BOREHOLE_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_PRODUCTION"].ID,
		RewardPerkType = "PLAYERPERK_BOREHOLES_PRODUCTION_MOD";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_BOREHOLE_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_BOREHOLE_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_ENERGY"].ID,
		RewardPerkType = "PLAYERPERK_BOREHOLES_ENERGY_MOD";
	}
}

-- AUGMENTERY
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_AUGMENTERY"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_AUGMENTERY",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_AUGMENTERY_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_AUGMENTERY_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_AUGMENTERY_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_AUGMENTERY_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_HEALTH"].ID,
		RewardPerkType = "PLAYERPERK_AUGMENTERIES_HEALTH_MOD";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_AUGMENTERY_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_AUGMENTERY_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_EXPANSION"].ID,
		RewardPerkType = "PLAYERPERK_AUGMENTERIES_ALL_YIELDS_MOD";
	}
}

-- MOLECULAR_FORGE
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_MOLECULAR_FORGE"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_MOLECULAR_FORGE",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_MOLECULAR_FORGE_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_MOLECULAR_FORGE_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_MOLECULAR_FORGE_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_MOLECULAR_FORGE_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_PRODUCTION"].ID,
		RewardPerkType = "PLAYERPERK_MOLECULAR_FORGES_PRODUCTION_MOD";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_MOLECULAR_FORGE_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_MOLECULAR_FORGE_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_SCIENCE"].ID,
		RewardPerkType = "PLAYERPERK_MOLECULAR_FORGES_SCIENCE_MOD";
	}
}

-- BIOGLASS_FURNACE
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_BIOGLASS_FURNACE"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_BIOGLASS_FURNACE",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_BIOGLASS_FURNACE_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_BIOGLASS_FURNACE_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_BIOGLASS_FURNACE_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_BIOGLASS_FURNACE_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_PRODUCTION"].ID,
		RewardPerkType = "PLAYERPERK_BIOGLASS_FURNACES_FIRAXITE_PRODUCTION";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_BIOGLASS_FURNACE_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_BIOGLASS_FURNACE_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_TILE_IMPROVEMENT"].ID,
		RewardPerkType = "PLAYERPERK_BIOGLASS_FURNACES_RESOURCE_FIRAXITE";
	}
}

-- NEOPLANETARIUM
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_NEOPLANETARIUM"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_NEOPLANETARIUM",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_NEOPLANETARIUM_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_NEOPLANETARIUM_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_NEOPLANETARIUM_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_NEOPLANETARIUM_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_ORBITAL"].ID,
		RewardPerkType = "PLAYERPERK_NEOPLANETARIUMS_ORBITAL_COVERAGE";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_NEOPLANETARIUM_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_NEOPLANETARIUM_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_PRODUCTION"].ID,
		RewardPerkType = "PLAYERPERK_NEOPLANETARIUMS_ORBITAL_PRODUCTION";
	}
}

-- NANOPASTURE
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_NANOPASTURE"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_NANOPASTURE",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_NANOPASTURE_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_NANOPASTURE_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_NANOPASTURE_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_NANOPASTURE_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_GROWTH"].ID,
		RewardPerkType = "PLAYERPERK_NANOPASTURE_FOOD_MOD";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_NANOPASTURE_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_NANOPASTURE_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_ENERGY"].ID,
		RewardPerkType = "PLAYERPERK_NANOPASTURE_ENERGY_MOD";
	}
}

-- FIELD_REACTOR
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_FIELD_REACTOR"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_FIELD_REACTOR",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_FIELD_REACTOR_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_FIELD_REACTOR_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_FIELD_REACTOR_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_FIELD_REACTOR_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_ENERGY"].ID,
		RewardPerkType = "PLAYERPERK_FIELD_REACTORS_ENERGY_MOD";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_FIELD_REACTOR_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_FIELD_REACTOR_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_ORBITAL"].ID,
		RewardPerkType = "PLAYERPERK_FIELD_REACTORS_ORBITAL_COVERAGE";
	}
}

-- SKYCRANE
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_SKYCRANE"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_SKYCRANE",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_SKYCRANE_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_SKYCRANE_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_SKYCRANE_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_SKYCRANE_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_PRODUCTION"].ID,
		RewardPerkType = "PLAYERPERK_SKYCRANES_FLOAT_STONE_PRODUCTION";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_SKYCRANE_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_SKYCRANE_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_TILE_IMPROVEMENT"].ID,
		RewardPerkType = "PLAYERPERK_SKYCRANES_RESOURCE_FLOAT_STONE";
	}
}

-- MANTLE
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_MANTLE"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_MANTLE",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_MANTLE_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_MANTLE_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_MANTLE_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_MANTLE_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_SCIENCE"].ID,
		RewardPerkType = "PLAYERPERK_MANTLES_PURITY_LVL_SCIENCE";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_MANTLE_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_MANTLE_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_ENERGY"].ID,
		RewardPerkType = "PLAYERPERK_MANTLES_PURITY_LVL_ENERGY";
	}
}

-- HYPERCORE
BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_HYPERCORE"].ID] = hmake BuildingQuestStruct {
	TitleTextKey = "TXT_KEY_QUEST_BUILDING_HYPERCORE",
	BodyTextKey = "TXT_KEY_QUEST_BUILDING_HYPERCORE_BODY",
	SummaryTextKey = "TXT_KEY_QUEST_BUILDING_HYPERCORE_SUMMARY",
	ChoiceA = hmake BuildingChoiceStruct {
		ID = 1,
		Text = "TXT_KEY_QUEST_BUILDING_HYPERCORE_CHOICE_A",
		Epilogue = "TXT_KEY_QUEST_BUILDING_HYPERCORE_EPILOGUE_A";
		Flavor = GameInfo.Flavors["FLAVOR_SCIENCE"].ID,
		RewardPerkType = "PLAYERPERK_HYPERCORES_SUPREMACY_LVL_SCIENCE";
	},
	ChoiceB = hmake BuildingChoiceStruct {
		ID = 2,
		Text = "TXT_KEY_QUEST_BUILDING_HYPERCORE_CHOICE_B",
		Epilogue = "TXT_KEY_QUEST_BUILDING_HYPERCORE_EPILOGUE_B";
		Flavor = GameInfo.Flavors["FLAVOR_CULTURE"].ID,
		RewardPerkType = "PLAYERPERK_HYPERCORES_SUPREMACY_LVL_CULTURE";
	}
}

-- TEMPLATE

--BUILDING_CHOICES_TABLE[GameInfo.Buildings["BUILDING_X"].ID] = hmake BuildingQuestStruct {
	--TitleTextKey = "TXT_KEY_QUEST_BUILDING_X",
	--BodyTextKey = "TXT_KEY_QUEST_BUILDING_X_BODY",
	--SummaryTextKey = "TXT_KEY_QUEST_BUILDING_X_SUMMARY",
	--ChoiceA = hmake BuildingChoiceStruct {
		--ID = 1,
		--Text = "TXT_KEY_QUEST_BUILDING_X_CHOICE_A",
		--Epilogue = "TXT_KEY_QUEST_BUILDING_X_EPILOGUE_A";
		--Flavor = GameInfo.Flavors[""].ID,
		--RewardPerkType = "";
	--},
	--ChoiceB = hmake BuildingChoiceStruct {
		--ID = 2,
		--Text = "TXT_KEY_QUEST_BUILDING_X_CHOICE_B",
		--Epilogue = "TXT_KEY_QUEST_BUILDING_X_EPILOGUE_B";
		--Flavor = GameInfo.Flavors[""].ID,
		--RewardPerkType = "";
	--}
--}

------------------------------------------------------
-- Game Events
------------------------------------------------------ 
-- Building Processed
function QuestScript.OnBuildingProcessed(playerID, buildingID, cityID, buildingAdded)
	
	if QuestScript.PersistentData.PlayerTriggerTables[playerID] ~= nil then
		local buildTableData = nil;
		for buildingTableID, buildingTableRow in ipairs(QuestScript.PersistentData.PlayerTriggerTables[playerID]) do
			if(buildingTableRow.BuildingID == buildingID) then
				buildTableData = buildingTableRow;
				break;
			end
		end

		if buildTableData ~= nil then
			-- data already exists, increment or decrement depending on whether the building is being added or removed
			if buildingAdded then
				buildTableData.TriggerChance = buildTableData.TriggerChance + TRIGGER_CHANCE;
			else
				buildTableData.TriggerChance = buildTableData.TriggerChance - TRIGGER_CHANCE;
			end
		else
			-- first building of its class, set base table data
			local newTableData = {};
			newTableData.TriggerChance = TRIGGER_CHANCE;
			newTableData.QuestStarted = false;
			newTableData.BuildingID= buildingID;
			table.insert(QuestScript.PersistentData.PlayerTriggerTables[playerID], newTableData);
		end
	else
		-- no player table for some reason
		error(string.format("No table for player %s in PlayerTriggerTables", playerID));
	end
end
GameEvents.BuildingProcessed.Add(QuestScript.OnBuildingProcessed);

-- Active Player Turn Start
function QuestScript.OnPlayerDoTurn(playerID)

	--print("QuestScript.OnPlayerDoTurn player " .. playerID);

	if QuestScript.PersistentData.PlayerTriggerTables[playerID] ~= nil then
		for i, buildingTable in ipairs(QuestScript.PersistentData.PlayerTriggerTables[playerID]) do

			-- Only check buildings that have entries in the BUILDING_CHOICES_TABLE
			if BUILDING_CHOICES_TABLE[buildingTable.BuildingID] ~= nil then

				if buildingTable.QuestStarted == false and buildingTable.TriggerChance > 0 then

					print("Rolling to start quest for Building: " .. tostring(GameInfo.Buildings[buildingTable.BuildingID].Type));
					local roll = Game.Rand(100, "Building Quest Trigger: player " .. playerID .. " BuildID " .. buildingTable.BuildingID);
					if (roll <= buildingTable.TriggerChance) then
						buildingTable.QuestStarted = true;	
						StartQuest(playerID, QuestScript.Info.ID, buildingTable.BuildingID);
						return;
					end
				end
			end
		end
	end
end
GameEvents.PlayerDoTurn.Add(QuestScript.OnPlayerDoTurn);

----------------------------------------------------
-- Callbacks
---------------------------------------------------- 
function QuestScript.OnInit()

	-- Init player-level trigger table
	QuestScript.PersistentData.PlayerTriggerTables = {};

	for playerType = 0, GameDefines.MAX_MAJOR_CIVS - 1, 1 do
		-- Init sub-table for building classes
		QuestScript.PersistentData.PlayerTriggerTables[playerType] = {};
	end
end

function QuestScript.OnStart(quest, buildingID)
	
	local choiceTable = BUILDING_CHOICES_TABLE[buildingID];
	if choiceTable == nil then
		error(string.format("Choice table not found for Building Choice quest for building ID %s", buildingID));
		return;
	end
	
	quest.PersistentData.BuildingID = buildingID;

	-- Set name override
	local titleText = Locale.Lookup(choiceTable.TitleTextKey);
	quest:SetNameOverride(titleText);

	-- Set the prologue
	local bodyText = Locale.Lookup(choiceTable.BodyTextKey);
	quest:SetPrologue(bodyText);

	--REF: (quest, "QUEST_OBJECTIVE_PROMPT", questName, prompt, optionA, optionB, optionC)
	local promptObjective = AddObjective(quest, "QUEST_OBJECTIVE_PROMPT", 
		titleText,
		--Locale.Lookup(choiceTable.SummaryTextKey),
		bodyText,
		hmake CvQuestPromptObjectiveOption{	Text =  choiceTable.ChoiceA.Text, 
													FlavorTypes = {
														choiceTable.ChoiceA.Flavor
													}},
		hmake CvQuestPromptObjectiveOption{	Text =  Locale.Lookup(choiceTable.ChoiceB.Text), 
													FlavorTypes = {
														choiceTable.ChoiceB.Flavor
													}}
	);

	-- Set optional tooltips for choice buttons
	if promptObjective ~= nil then
		local rewardA = GameInfo.PlayerPerks[choiceTable.ChoiceA.RewardPerkType];
		if rewardA ~= nil then
			promptObjective:SetPromptTooltipA(Locale.Lookup(rewardA.Help));
		end

		local rewardB = GameInfo.PlayerPerks[choiceTable.ChoiceB.RewardPerkType];
		if rewardB ~= nil then
			promptObjective:SetPromptTooltipB(Locale.Lookup(rewardB.Help));
		end
	end

	-- set prompt image
	promptObjective:SetPromptImagePath(GameplayUtilities.PromptImageDomestic);
end

function QuestScript.OnObjectiveComplete(quest, objective)

	if (objective.PersistentData.Choice ~= nil) then

		local choiceTable = BUILDING_CHOICES_TABLE[quest.PersistentData.BuildingID];
		if choiceTable == nil then
			error(string.format("Choice table not found for Building Choice quest for building ID %s", quest.PersistentData.BuildingID));
			return;
		end

		local pPlayer = Players[objective:GetOwner()];
		local rewardPerkInfo = nil;

		if (objective.PersistentData.Choice == choiceTable.ChoiceA.ID) then
			
			objective:SetEpilogue(Locale.Lookup(choiceTable.ChoiceA.Epilogue));
			rewardPerkInfo = GameInfo.PlayerPerks[choiceTable.ChoiceA.RewardPerkType];

		elseif (objective.PersistentData.Choice == choiceTable.ChoiceB.ID) then

			objective:SetEpilogue(Locale.Lookup(choiceTable.ChoiceB.Epilogue));
			rewardPerkInfo = GameInfo.PlayerPerks[choiceTable.ChoiceB.RewardPerkType];

		else
			error("Unhandled Choice Value");
			return;
		end

		if rewardPerkInfo ~= nil then
			
			-- give player perk
			pPlayer:AddPerk(rewardPerkInfo.ID);

			-- Set reward string
			quest:SetReward(Locale.Lookup(rewardPerkInfo.Help));
			
			quest:Succeed();
		end
	end
end

return QuestScript;
